/***************************************************************************
    libBIOS - A portable library for developing an OpenSource BIOS
    Copyright (C) 2001 - David Aparicio

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Author can be reached at 'daparic@terra.es'
****************************************************************************/
// 
/*
 * include/asm-arm/ali1543.h
 *
 * Created daparic 25/05/2000 (STANDALONE)
 *
 * SouthBridge registers (STANDALONE version)
 */
#ifndef _ALI1543_H
#define _ALI1543_H

#define M1543_PNPCFG	0x370
#define M1543_PNPIDX	0x370
#define M1543_PNPDAT	0x371

#define M1543_SETDEV(x)	*PCIPORT(M1543_PNPIDX)=7, *PCIPORT(M1543_PNPDAT)=(x)

#define M1543_DEVFDC 0
#define M1543_DEVPP0 3
#define M1543_DEVUA0 4
#define M1543_DEVUA1 5
#define M1543_DEVKBD 7

#define PORT_PP0 0x0300
#define PORT_SP0 0x0310

#define PP0_ECPCFG (PORT_PP0+0x402)
#define PP0_SPPDAT (PORT_PP0+0x000)
#define PP0_SPPSTA (PORT_PP0+0x001)
#define PP0_SPPCTL (PORT_PP0+0x002)
#define PP0_ECPADR (PORT_PP0+0x003)
#define PP0_ECPDAT (PORT_PP0+0x004)

#define SP0_DATA   (PORT_SP0+0x000)
#define SP0_LBAUD  (PORT_SP0+0x000)
#define SP0_INTCTL (PORT_SP0+0x001)
#define SP0_HBAUD  (PORT_SP0+0x001)
#define SP0_FIFCTL (PORT_SP0+0x002)
#define SP0_LINCTL (PORT_SP0+0x003)
#define SP0_MODCTL (PORT_SP0+0x004)
#define SP0_LINSTA (PORT_SP0+0x005)
#define SP0_MODSTA (PORT_SP0+0x006)

#define PORT_UA0 0x0308
#define PORT_UA1 0x0310

#endif
