
/***************************************************************************
    libBIOS - A portable library for developing an OpenSource BIOS
    Copyright (C) 2001 - David Aparicio

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Author can be reached at 'daparic@terra.es'
****************************************************************************/
// 
#include "emOS.h"
#include "dc21285.h"

#ifdef DEPURACION
const char *_tlab[] = {
        "Free", "Ready", "WaitS", "WaitR"
	};

void _printTcbQ(tcb_t *tcbQ)
{
        tcb_t *aux = tcbQ;

        if(!aux)
                printk("(null)\n");
        else while(aux)
        {
                printk("%i(%s) %c", aux-sys.TCB, _tlab[aux->status],
                         aux->n == tcbQ ? '\n' : '>');
		if(aux->n==tcbQ) break;
                aux = aux->n;
        }
}

const char *_mlab[] = {
        "Free",
        "User",
        "Krnl"
        };

void _printMcbQ(mcb_t *mcbQ)
{
        mcb_t *aux = mcbQ;

        if(!aux)
                printk("(null)\n");
        else while(aux)
        {
                printk("%i(%s) %c", aux-sys.MCB, _mlab[MCBHDR(aux).status],
                         MCBHDR(aux).n == mcbQ ? '\n' : '>');
		if(MCBHDR(aux).n==mcbQ) break;
                aux = MCBHDR(aux).n;
        }
}

const char *_elab[] = {
        "?",
        "taskSync",
        "taskAsyn",
        "mcbTimer"
        };

void _printEcbQ(timer_t *tmrQ)
{
        timer_t *aux = tmrQ;

        if(!aux)
                printk("(null)\n");
        else while(aux)
        {
                printk("%i(%s[%i]) %c", aux->tics_left, _elab[aux->tipo],
			aux->tipo==TIMER_MCB
				? aux->i.mcb-sys.MCB
				: aux->i.tcb-sys.TCB,
                        !aux->n || aux->n==tmrQ ? '\n' : '>');
		if(!aux->n || aux->n==tmrQ) break;
                aux = aux->n;
        }
}
#endif

void stub_debug(u32 pc)
{
	printk("PC: %08X, TIC: %i\n", pc, sys.tic);
//	while(keysleft()) getc();
}
