
/***************************************************************************
    libBIOS - A portable library for developing an OpenSource BIOS
    Copyright (C) 2001 - David Aparicio

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Author can be reached at 'daparic@terra.es'
****************************************************************************/
// 
	.text

	.globl	memcpy
memcpy:
1:	subs	r2, r2, #1
	ldrplb	r3, [r1], #1
	strplb	r3, [r0], #1
	bpl	1b
	mov	pc, lr

	.globl	memzero
memzero:
	mov	r2, r1
	mov	r1, #0

	.globl	memset
memset:
1:	subs	r2, r2, #1
	strplb	r1, [r0], #1
	bpl	1b
	mov	pc, lr


	.globl	memeq
memeq:
	teq	r2, #0
	moveq	r0, #1
	moveq	pc, lr
1:	ldrb	r3, [r0], #1
	ldrb	ip, [r1], #1
	teq	r3, ip
	movne	r0, #0
	movne	pc, lr
	subs	r2, r2, #1
	bne	1b
	mov	r0, #1
	mov	pc, lr

	.globl	strcpy
strcpy:
1:	ldrb	r3, [r1], #1
	strb	r3, [r0], #1
	teq	r3, #0
	bne	1b
	mov	pc, lr

	.globl	strnlen
strnlen:
	add	r3, r0, #1
1:	ldrb	r2, [r0], #1
	teq	r2, #0
	subnes	r1, r1, #1
	bne	1b
	sub	r0, r0, r3
	mov	pc, lr
