
/***************************************************************************
    libBIOS - A portable library for developing an OpenSource BIOS
    Copyright (C) 2001 - David Aparicio

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Author can be reached at 'daparic@terra.es'
****************************************************************************/
// 
#include "emOS.h"
#include "macros.h"

	.macro	trap, knlCall, numCall
	ldr	r3, =_user_mode
	ldr	r3, [r3]
	cmp	r3, #0
	beq	\knlCall	// if(!_user_mode) knlCall(ARGS)
	swine	#\numCall	// if(_user_mode)  SWI #numCall
	.endm

//------------
	.globl	entry
	.globl	KNLreset
	.globl	_emOSnew
	.globl	_emOSfree
	.globl	_emOSjoin
	.globl	_emOSsplit
	.globl	_emOSsend
	.globl	_emOSrecv
	.globl	_emOSbind
	.globl	_emOSunbind

//------------
entry:		swi	#TRAP_KNL_RESET
		mov	pc, lr

KNLreset:	trap	exit,       TRAP_KNL_EXIT

_emOSnew:	trap	sysMSGnew,    TRAP_MSG_NEW
_emOSfree:	trap	sysMSGfree,   TRAP_MSG_FREE
_emOSjoin:	trap	sysMSGjoin,   TRAP_MSG_JOIN
_emOSsplit:	trap	sysMSGsplit,  TRAP_MSG_SPLIT

_emOSbind:	trap	sysMSGbind,   TRAP_MSG_BIND
_emOSunbind:	trap	sysMSGunbind, TRAP_MSG_UNBIND
_emOSsend:	trap	sysMSGsend,   TRAP_MSG_SEND
_emOSrecv:	trap	sysMSGrecv,   TRAP_MSG_RECV

        .data
        .globl  _user_mode
_user_mode:     .long   0

