
/***************************************************************************
    libBIOS - A portable library for developing an OpenSource BIOS
    Copyright (C) 2001 - David Aparicio

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Author can be reached at 'daparic@terra.es'
****************************************************************************/
// 
#include "macros.h"

	.globl	tr0_RES
	.globl	tr1_UND
	.globl	tr2_SWI
	.globl	tr3_CFT
	.globl	tr4_DFT
	.globl	tr5_E26
	.globl	tr6_IRQ
	.globl	tr7_FIQ

//---------------- tratamiento de trap por defecto
tr0_RES:  printz  lbl0
1:        B       1b

tr1_UND:  printz  lbl1
1:        B       1b

tr2_SWI:  printz  lbl2
1:        B       1b

tr3_CFT:  printz  lbl3	// CODE FAULT
1:        B       1b

tr4_DFT:  printz  lbl4	// DATA FAULT
1:        B       1b

tr5_E26:  printz  lbl5
1:        B       1b

tr6_IRQ:  printz  lbl6
1:        B       1b

tr7_FIQ:  printz  lbl7
1:        B       1b

lbl0:   .ascii  "\r\nTRAP#0: RESET\r\n\0"
lbl1:   .ascii  "\r\nTRAP#1: Undefined Instruction\r\n\0"
lbl2:   .ascii  "\r\nTRAP#2: SWI\r\n\0"
lbl3:   .ascii  "\r\nTRAP#3: PrefetchAbort\r\n\0"
lbl4:   .ascii  "\r\nTRAP#4: DataAbort\r\n\0"
lbl5:   .ascii  "\r\nTRAP#5: ARM26 MMU\r\n\0"
lbl6:   .ascii  "\r\nTRAP#6: IRQ\r\n\0"
lbl7:   .ascii  "\r\nTRAP#7: FIQ\r\n\0"

