
/***************************************************************************
    libBIOS - A portable library for developing an OpenSource BIOS
    Copyright (C) 2001 - David Aparicio

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Author can be reached at 'daparic@terra.es'
****************************************************************************/
// 
#include <stdarg.h>
#include "libBIOS.h"
#include "dc21285.h"

LIBENTRY void kputs(unsigned char *str)	// Escribe string (con reintentos)
{
	while(*str)
	{
		if(*str=='\n')	// Convierte CR en LF+CR
		{
			putc('\r');
			putc(*str);
		}
		else if(*str>=' ')	// Imprime solo char visualizables
			putc(*str);
		else if(*str=='\b' || *str=='\r')	// Tambien estos...
			putc(*str);
		str++;
	}
}

LIBENTRY int printk(char *mask, ...)
{
	int len;
	va_list ap;
	char s[4096];

	va_start(ap, mask);
	len = vsprintf(s, mask, ap);
	kputs(s);
	va_end(ap);
	while(*CSR_UARTFLG & FLG_UART_TXCHARSLEFT) {}
	return len;
}

LIBENTRY void kgets(unsigned char *str)
{
	u32 n = 0;
	while(1)
	{
		*str = getc();

		switch(*str)
		{
		case 0x0D:		// End of STRING
			kputs("\n");
			*str = 0;
			return;
		case 0x08:		// DELETE CHAR
			if(!n) break;
			n--; str--;
			putc(8); putc(' '); putc(8);
			break;
		case 0x1B:		// ANSI CODE
			getc();
			getc();
			break;
		default:
			if(*str>=' ' && *str<=126)
			{
				putc(*str);
				n++; str++;
			}
			break;
		}
	}
}

