#ifndef __SHELL
#define __SHELL

#include <libBIOS.h>

//*** parser.c
#define FNUL (fun_t)0;
typedef int (* fun_t)(char **s);

typedef	struct {
		char *name;
		fun_t fun;
		int   flags;
		} cmds_t;

int getword  (char **s, char *w);
int getnumber(char **s, u32 *n);
int getrange (char **s, u16 *n, u32 ln[]);
int parseline(char *command);

int do_macro(char **s);
int do_batch(char **s);
int do_null (char **s);
int do_quit (char **s);
int do_begin(char **s);
int do_end  (char **s);
int do_void (char **s);
int do_help (char **s);
int do_pci (char **s);
int do_map (char **s);
int do_sfs (char **s);

//extern char *nm_batch;
//char *is_batch(void);
//int script(char *file, u32 addr, u32 size);

//*** command.c
void exec_call(u32 addr);
extern const cmds_t cmds[];

//*** ioctl.c
void   rdmem(u16 tipo, u16 nelem, u32 elem[], u16 bytesize);
void   wrmem(u16 tipo, u16 nelem, u32 elem[], u32 val, u16 bytesize);
void   rapp(void);
void   rdpp(void);
void   wapp(u32 val);
void   wdpp(u32 val);
int    lcaInit(u8 *addr, mbE_t *dir);

int    rtc_init(void);
u8     rtc_read (u8 offs);
void   rtc_write(u8 offs, u8 val);

//*** pci.c
void   cmd_pci(int dev);
void   cmd_map(int dev);

//*** sfs.c
mbE_t *cmd_sfs(char c, u32 n, u8 **addr);

//*** rom.c
void	rom_check(u32 baseaddr);
void	rom_lock(u32 baseaddr);
void	rom_burn(u32 baseaddr, u8 *data, u32 size);

#endif // __SHELL
