#include "mon.h"

static void copy_segment(u8 *des, u8 *ori, u32 sze)
{
	if(ori == des || !sze) return;
	printk("Copying 0x%08X -> 0x%08X (%i bytes)\n", ori, des, sze);
	memcpy(des, ori, sze);
}

void burn(mbE_t *dir, u8 *addr)
{
	mbE_t *rom = (void *)ADDR_POST;

	printk("Ready to BURN %s [0x%08X(%i) to 0x%08X]? "
		"(press 'f' to proceed)\n",
		 dir->label, addr, dir->sizeC + dir->sizeD, rom->baseD);
	if(getc()=='f')
		rom_burn((u32)rom->baseD, addr, dir->sizeC + dir->sizeD);
}

void copy(mbE_t *dir, u8 *addr)
{
	u32 pcibase = 0;	// offset for BAR[SDRAM] for target device

	if(addr == dir->baseC)
		printk("NULL 0x%08X %s\n", addr, dir->label);
	else
	{
		printk("COPY 0x%08X %s\n", addr, dir->label);
		copy_segment(pcibase+dir->baseC, addr,              dir->sizeC);
		copy_segment(pcibase+dir->baseD, addr + dir->sizeC, dir->sizeD);
	}
}

u32 gram, grom;

u32 entry(env_t *env)
{
	extern void _start(void);
	csrGrp_t grp;
	u32      i, j;
	mbA_t *hdr   = (void *)_start;

	printk("=(3)========================================\n");
	printk("            [FW"DATE" MONITOR]\n");
	printk("============================================\n");
	rom_check(ADDR_POST);
	gram = env->ramsize;
	grom = env->romsize;

	while(1)
	{
		char s[4096];
		int  r;

		printk("-> ");
		kgets(s);
		r = parseline(s);
		if(r<0) break;
	}
	return ADDR_POST;
//	exit(ADDR_POST);

#ifdef NEVER
#define HDR(I)	hdr->dir[I]
#define IMG_EOF(I)	!(HDR(I).offset)
#define IMG_HEAD(I) ((mbA_t *)(HDR(I).offs + _start))
#define IMG_SIZE(I)           (HDR(I).sizeC + HDR(I).sizeD)
	pci_grpScan(grp);
	//--- Flash all images on daughercards
	for(i=0; !IMG_EOF(i); i++)
	{
		//--- Search device for this image
		if(IMGID_NONPCI(HDR(i).magic))	// Non PCI device
			do_burn(NULL, 0, &HDR(i));
		else for(j=1; grp[j].csr; j++)		// Default PCI search
			if(PCI_DEVICE(grp[j].csr)==HDR(i).magic)
			{
				u32 addr = pci_getAddr(grp[j].addr[PCI_GRPROM][0]);

				do_burn(grp[j].csr, pci_bus2ram(addr), IMG_HEAD(i));
			}
	}
	//--- Now Flash image on this host
	for(i=0; !IMG_EOF(i); i++)
		if(IMG_HEAD(i)->magic == hdr->magic)
			do_burn(grp[0].csr, DC21285_FLASH, IMG_HEAD(i));

	printk("Done. Reset SYSTEM\n");
	while(1) {}
	return ADDR_POST;
#endif
}

